target=ordre
U3/algebra/oefpartition.fr
#define LEVEL A
#include "lang_titles.inc"
#include "lang.inc"
#include "author.inc"

\text{n=randint(8..14)}
\integer{N=4}
\text{partition=\n}
\text{choix=10}
\text{Choix=shuffle(\choix)}
\text{Choix=\Choix[1..\N]}
%% utiliser le slib ?
\text{programme=pari((suivant(p) = n=sum(i=1,#p,p[i]);
  L=listcreate(n); test=0; for( a = 1, #p,
    if(a <#p && p[a+1] > 1,listput(L,p[a]),
      listput(L, p[a]-1); test=1; N=#p-a +1; s=divrem(N,p[a]-1)~;
      for(j=1 , s[1], listput(L,p[a]-1));
        if(s[2]!=0, listput(L,s[2]) ); return(Vec(L)); break)
  )))
}
\text{P=}
\text{Image=}
\integer{w=0}
\integer{h=0}
\integer{size=15}
\for{j=1 to 10}{
  \text{partition=pari(suivant([\partition]))}
  \text{P=wims(append item [\partition] to \P)}
  \integer{w=\j isitemof \Choix ? max(\w,\partition[1])}
  \text{hh=items(\partition)}
  \integer{h=\j isitemof \Choix ? max(\h,\hh)}
}
\integer{SIZEw=(1+\w)*\size}
\integer{SIZEh=(1+\h)*\size}
\integer{sIZEw=\SIZEw}
\integer{sIZEh=\SIZEh}
\for{u=1 to 10}{
  \text{pp=\P[\u]}
  \text{image=slib(algebra/partitiondraw \pp,\size,\SIZEw,\SIZEh)}
  \integer{sIZEw=max(\SIZEw,\image[2])}
  \integer{sIZEh=max(\SIZEh,\image[3])}
  \text{Image=\u isitemof \Choix ? wims(append item \image[1] to \Image)}
}
\statement{\name_enonce
<div class="wimscenter">
\embed{r1,\sIZEw x \sIZEh}
</div>
}
\answer{}{\Image}{type=dragfill}{option=shuffle}

\help{\name_help_order}
La liste de toutes les partitions de n dans l'ordre dcroissant est donne par un algorithme
itratif.
Si une partition est reprsente par une suite finie dcroissante (a_i) dont au moins un
terme est strictement suprieur  1, la partition suivante (b_i) est construite comme suit :

    On note k le rang du dernier terme strictement suprieur  1 et N le nombre de termes
    qui valent 1 dans (a_i).
    Pour tout j < k, on dfinit b_j = a_j.
    On dfinit b_k = a_k - 1.
    En notant N = b_kq + r la division euclidienne de N par b_k, on dfinit
    les termes b_j pour k < j < k + q + 1 par b_j = b_k.
    Si r est non nul, on dfinit un dernier terme b_k + q + 1 = r.
